/*
 * Exemplo de uso de memria compartilhada.  Associao do mesmo
 * segmento prximo  rea de pilha e prximo  rea de dados.
 */ 
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>

#define SHMSZ 27 /* Ser arredondado para um mltiplo de PAGE_SIZE */

char str_global[10];

int main() {
  int shmid;
  key_t key;
  char str_local[10];
  char *shm_dados, *shm_pilha;
  char c, *s;
  
  /* Chave arbitrria para o segmento compartilhado */
  key = 5677;

  /* Criao do segmento de memria e obteno do seu identificador. */
  if ((shmid = shmget(key, SHMSZ, IPC_CREAT | 0666)) < 0) {
    perror("shmget");
    exit(1);
  }
  
  /* Tentativa de associao prximo  rea de pilha. */
  if ((shm_pilha = shmat(shmid, str_local-0x100000, SHM_RND)) == (char *) -1) {
    printf("shmat at %p\n", str_local-0x100000);
    perror("shmat");
    exit(1);
  }
  
  /* Tentativa de associao prximo  rea de dados. */
  if ((shm_dados = shmat(shmid, str_global+0x10000, SHM_RND)) == (char *) -1) {
    printf("shmat at 0x%x\n", (unsigned int) str_global+0x1000);
    perror("shmat");
    }

  
  printf("str_local  = %p\n", str_local);
  printf("shm_pilha  = %p\n", shm_pilha);
  printf("shm_dados  = %p\n", shm_dados);    
  printf("str_global = %p\n", str_global);
  printf("main       = %p\n", (void *) main);

  /* Preenche o segmento com o alfabeto */
  s = shm_pilha;
  for (c = 'a'; c <= 'z'; c++)
    *s++ = c;
  *s = '\0';

  /* Verifica o preenchimento nos dois endereo */
  printf("SHM_Pilha: %s\n", shm_pilha);
  printf("SHM_Dados: %s\n", shm_dados);
  
  return 0;
}
