/*
 * Exemplo de uso de memria compartilhada.  
 */ 
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <semaphore.h>

#define SHMSZ 27 /* Ser arredondado para um mltiplo de PAGE_SIZE */

char str_global[10];

int main() {
  int shmid;
  key_t key;
  char *shm;
  sem_t *sem;
  
  /* Chave arbitrria para o segmento compartilhado */
  key = 5677;

  /* Criao do segmento de memria e obteno do seu identificador. */
  if ((shmid = shmget(key, SHMSZ, IPC_CREAT | 0666)) < 0) {
    perror("shmget");
    exit(1);
  }
  
  /* Tentativa de associao prximo  rea de dados. */
  if ((shm = shmat(shmid, str_global+0x10000, SHM_RND)) == (char *) -1) {
    printf("shmat at %p\n", str_global+0x1000);
    perror("shmat");
    }

  printf("Processo servidor: %s\n", shm);

  sem = (sem_t*) shm;

  sem_init(sem, 1, 0);
  
  sleep(5);

  sem_post(sem);

  return 0;
}
